﻿using System.Linq;
using Luticate2.Auth.DataAccess;
using Luticate2.Auth.DataAccess.Models;
using Microsoft.EntityFrameworkCore;
using Xunit;

namespace Luticate2.Auth.Tests
{
    public class RandomTests
    {
        [Fact]
        public void Test1()
        {
            var dbContext = new luticate2Context();
            var items = dbContext.LuGroups.Where(groups => groups.LuGroupsObjects.Any(x => x.Priority == 0));
            var list = items.ToList();
            Assert.NotNull(list);
            Assert.Equal(1, list.Count);
        }

        [Fact]
        public void Test2()
        {
            var dbContext = new luticate2Context();
            var items = dbContext.LuGroups.OrderBy(x => x.Id).Where(groups => groups.LuGroupsObjects.Any(x => x.Priority == 0));
            var list = items.ToList();
            Assert.NotNull(list);
            Assert.Equal(1, list.Count);
        }

        [Fact]
        public void Test3()
        {
            var dbContext = new luticate2Context();
            var items = dbContext.LuGroups.OrderBy(x => x.Id);
            var list = items.ToList();
            Assert.NotNull(list);
            Assert.Equal(2, list.Count);
        }
    }
}