﻿using System;
using System.Linq.Expressions;
using Luticate2.Auth.Business.Fields;
using Luticate2.Auth.Business.FieldsExpressions;
using Luticate2.Auth.DataAccess.Models;
using Luticate2.Auth.Dbo.Auth;
using Luticate2.Auth.Dbo.Fields;
using Luticate2.Auth.Dbo.Result;

namespace Luticate2.Auth.Business.Auth.FieldsExpressions
{
    public class LuFieldsExpressionsLuGroupDboLuGroups : LuFieldsExpressions<LuGroupDbo, LuGroups>
    {
        public LuFieldsExpressionsLuGroupDboLuGroups(IServiceProvider serviceProvider) : base(serviceProvider)
        {
        }

        protected override LuResult<Expression<Func<TType1, object>>> GetExpressionInternal<TType1>(
            Expression<Func<TType1, LuGroups>> modelProperty, LuFieldDbo field)
        {
            if (field.StartsWith<LuGroupDbo>(x => x.Id))
            {
                return GetSubField<TType1, Guid, Guid>(modelProperty, field, x => x.Id);
            }
            else if (field.StartsWith<LuGroupDbo>(x => x.Name))
            {
                return GetSubField<TType1, string, string>(modelProperty, field, x => x.Name);
            }
            else if (field.StartsWith<LuGroupDbo>(x => x.Metadata))
            {
                return GetSubField<TType1, LuObjectsMetadataDbo, LuObjectsMetadata>(modelProperty, field, x => x.IdNavigation);
            }

            return base.GetExpressionInternal(modelProperty, field);
        }
    }
}