﻿using System;
using System.Linq.Expressions;
using Luticate2.Auth.Business.Fields;
using Luticate2.Auth.Business.FieldsExpressions;
using Luticate2.Auth.DataAccess.Models;
using Luticate2.Auth.Dbo.Auth;
using Luticate2.Auth.Dbo.Fields;
using Luticate2.Auth.Dbo.Result;

namespace Luticate2.Auth.Business.Auth.FieldsExpressions
{
    public class LuFieldsExpressionsLuMetadataDboLuMetadata : LuFieldsExpressions<LuObjectsMetadataDbo, LuObjectsMetadata>
    {
        public LuFieldsExpressionsLuMetadataDboLuMetadata(IServiceProvider serviceProvider) : base(serviceProvider)
        {
        }

        protected override LuResult<Expression<Func<TType1, object>>> GetExpressionInternal<TType1>(Expression<Func<TType1, LuObjectsMetadata>> modelProperty, LuFieldDbo field)
        {
            if (field.StartsWith<LuObjectsMetadataDbo>(x => x.Id))
            {
                return GetSubField<TType1, Guid, Guid>(modelProperty, field, x => x.Id);
            }
            if (field.StartsWith<LuObjectsMetadataDbo>(x => x.CreatedAt))
            {
                return GetSubField<TType1, DateTime, DateTimeOffset>(modelProperty, field, x => x.CreatedAt);
            }
            if (field.StartsWith<LuObjectsMetadataDbo>(x => x.UpdatedAt))
            {
                return GetSubField<TType1, DateTime?, DateTimeOffset?>(modelProperty, field, x => x.UpdatedAt);
            }

            return base.GetExpressionInternal(modelProperty, field);
        }
    }
}