﻿using System;
using Luticate2.Auth.Business.PartialObjectCopier;
using Luticate2.Auth.DataAccess.Models;
using Luticate2.Auth.Dbo.Auth;
using Luticate2.Auth.Dbo.Fields;
using Luticate2.Auth.Dbo.PartialObjectCopier;
using Luticate2.Auth.Dbo.Result;

namespace Luticate2.Auth.Business.Auth.PartialObjectCopier
{
    public class LuPOCGroupsToModel : LuPartialObjectCopier<LuGroupDbo, LuGroups>
    {
        public LuPOCGroupsToModel(IServiceProvider serviceProvider) : base(serviceProvider)
        {
        }

        public override LuResult<LuGroups> Copy(LuFieldDbo path, LuPartialFieldsDbo fields, LuGroupDbo dboFrom, LuGroups modelTo,
            LuPartialObjectCopierOptions options)
        {
            MayCopy(path, fields, modelTo, model => model.Id, () => dboFrom.Id);
            MayCopy(path, fields, modelTo, model => model.Name, () => dboFrom.Name);

            return LuResult<LuGroups>.Ok(modelTo);
        }
    }
}