﻿using System;
using System.Linq.Expressions;
using Luticate2.Auth.Business.Fields;
using Luticate2.Auth.Dbo.Fields;
using Luticate2.Auth.Dbo.Result;

namespace Luticate2.Auth.Business.FieldsExpressions.Basic
{
    public class LuFieldsExpressionsString : LuFieldsExpressions<string, string>
    {
        public LuFieldsExpressionsString(IServiceProvider serviceProvider) : base(serviceProvider)
        {
        }

        protected override LuResult<Expression<Func<TType1, object>>> GetExpressionInternal<TType1>(Expression<Func<TType1, string>> modelProperty, LuFieldDbo field)
        {
            if (field.StartsWith<string>(x => x.Length))
            {
                return GetSubField<TType1, int, int>(modelProperty, field, x => x.Length);
            }
            return base.GetExpressionInternal(modelProperty, field);
        }
    }
}