﻿using System.Collections.Generic;
using Luticate2.Auth.Dbo.Fields;
using Luticate2.Auth.Dbo.Pagination;
using Luticate2.Auth.Dbo.Result;

namespace Luticate2.Auth.Interfaces
{
    public interface ILuCrud<TDbo>
    {
        LuResult<IList<TDbo>> Create(LuPartialFieldsDbo partialResponse, LuPartialFieldsDbo partialInput, IEnumerable<TDbo> dbos);
        
        LuResult<LuPaginatedDbo<TDbo>> Read(LuPartialFieldsDbo partialResponse, LuPaginatedParamsDbo paginationParams);
        
        LuResult<IList<TDbo>> Update(LuPartialFieldsDbo partialResponse, LuPartialFieldsDbo partialInput, IEnumerable<TDbo> dbos);
        
        LuResult<IList<TDbo>> Delete(LuPartialFieldsDbo partialResponse, LuPartialFieldsDbo partialInput, IEnumerable<TDbo> dbos);
    }
}